Recently one of my customer updated that when he tried connecting to a mailbox that is located on a  Exchange Server 2010 from Exchange Server 2003 by using a custom MAPI/C++ application. But it failed and it thrown the following error message: “MAPI_E_FAILONEPROVIDER”.

As part of troubleshooting the issue, we tried using MFC MAPI utility and can reproduce the issue. During troubleshooting, we found that this issue occurs because the MAPI subsystem on an Exchange Server 2003 server is not designed to be used on an Exchange Server 2010 server.

To resolve this issue, we recommended to use the following Exchange MAPI subsystem on an Exchange Server 2010 server/on a Exchange Server 2007 server.

Please note that the Exchange MAPI client and Collaboration Data Objects (CDO) 1.2.1 can be installed only on Exchange 2007 and Exchange 2010 servers. Additionally, it includes the MAPI client libraries and supports CDO 1.2.1. However, you cannot install this download on an Exchange 2003 server.

Download:

1) You can download the MAPI Sub system @ Microsoft Exchange Server MAPI client and Collaboration Data Objects 1.2.1

2) You can download the MFC MAPI Utility @ http://mfcmapi.codeplex.com/